/*************************************************************************\
  "icoutput.hpp" - Intermediate Code Output (Phase E)
  Revision 9; 10 Nov 2002 - 15 March 2004
  Copyright (C) 2002-2004  Kevin P. Albrecht
\*************************************************************************/

#ifndef ICOUTPUT_HPP
#define ICOUTPUT_HPP

/////////////////////////
// DEFINES //////////////
/////////////////////////

//#define ICOUTPUT_PRINT_LINE_NUM

/////////////////////////
// INCLUDES /////////////
/////////////////////////

/////////////////////////
// DECLARATIONS /////////
/////////////////////////

// External //
void icoutput (char *filename);

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

//// icmoutput
//// Output intermediate code to file
void icoutput (char *filename)
{
  // Vars //
  FILE *fileout;
  Statement *sm;
  int nInstruction = 0;
  char *temp = NULL;

  // Open File //
  fileout = fopen (filename, "w");

  sm = gICM->getNext ();
  nInstruction++;

  while (sm != NULL)
  {
    if (sm->op == tt__Buffer)
    {
      fprintf (fileout, "\n#### %s\n", (char *)(sm->sym->value));
    }
    else
    {
      #ifdef ICOUTPUT_PRINT_LINE_NUM
        fprintf (fileout, "%d\t", nInstruction);
      #endif
      fprintf (fileout, "%s", gvsOpCodeStrings[sm->op]);

      if (sm->sym != NULL)
      {
        if (sm->sym->rep == repIdent)
        {
          if (sm->op == ttColon)
          {
            fprintf (fileout, "%s", sm->sym->key);
          }
          else
          {
            if (sm->sym->uid)
              fprintf (fileout, " %s%s", sm->sym->uid, sm->sym->key);
            else
              fprintf (fileout, " %s", sm->sym->key);
          }
        }
        else
        {
          if (sm->sym->type == tLabel)
          {
            temp = k_conv_is (*((int*)sm->sym->value));
            fprintf (fileout, " %s", temp);
          }
          else if (sm->sym->type == tRoutine)
          {
            fprintf (fileout, " %s", (char *)( ((Routine *)(sm->sym->value))->location->key ));
          }
          else if (sm->sym->type == tInt)
          {
            temp = k_conv_is (*((int*)sm->sym->value));
            fprintf (fileout, " %s", temp);
          }
          else if (sm->sym->type == tRat)
          {
            //temp = k_conv_ds (*((double*)sm->sym->value), GLOBAL_MANTISSA_SIZE);
            fprintf (fileout, " %.13f", *((double*)sm->sym->value));
          }
          else if (sm->sym->type == tBool)
          {
            bool btemp = *((bool*)sm->sym->value);
            if (btemp == true)
            {
              temp = k_clone ("true");
            }
            else
            {
              temp = k_clone ("false");
            }
            fprintf (fileout, " %s", temp);
          }
          else if (sm->sym->type == tStr)
          {
            if (sm->sym->value == NULL)
              fprintf (fileout, " \"\"");
            else
              fprintf (fileout, " \"%s\"", (char *)(sm->sym->value));
          }

          if (temp)
          {
            k_del_s (temp);
            temp = NULL;
          }
        }
      }
    }
    fprintf (fileout, "\n");
    
    sm = gICM->getNext();
    nInstruction++;
  }

  // Close File //
  fclose (fileout);
}

#endif
