/***************************************************************************\
  "unique.hpp" - Unique Name Generator (Phase D)
  Revision 5; 10 Nov 2002 - 15 March 2004
  Copyright (C) 2002-2004  Kevin P. Albrecht
\***************************************************************************/

#ifndef UNIQUE_HPP
#define UNIQUE_HPP

/////////////////////////
// DEFINES //////////////
/////////////////////////

#define UNIQUE_MAX_NAMES     32768
#define UNIQUE_NAME_LEN      256
#define UNIQUE_NAME_PREFIX   "__u"
#define UNIQUE_NAME_SUFFIX   "__"

/////////////////////////
// INCLUDES /////////////
/////////////////////////

// Standard //

// Local //

/////////////////////////
// DECLARATIONS /////////
/////////////////////////

class UniqueGenerator
{
  public:
    UniqueGenerator ();

    char *maked (char *s);
    char *make (char *s);

  private:
    int mIndex; // current unique index number
};

/////////////////////////
// DEFINITIONS //////////
/////////////////////////

UniqueGenerator::UniqueGenerator ()
{
  mIndex = 0;
}

char *UniqueGenerator::maked (char *s)
{
  char *temp = make (s);
  k_del_s (s);
  return temp;
}

char *UniqueGenerator::make (char *s)
{
  char *temp;

  if ((mIndex + 1) >= UNIQUE_MAX_NAMES)
  {
    err (true, EI_MAX_UNIQUE_NAMES_EXCEEDED, NULL);
    errterm ();
  }

  temp = k_new_s (UNIQUE_NAME_LEN);
  sprintf (temp, "%s%d%s%s",
           UNIQUE_NAME_PREFIX, mIndex, UNIQUE_NAME_SUFFIX, s);

  /* OLD WAY
  k_copy (temp, UNIQUE_NAME_PREFIX);
  k_catd (temp, k_conv_is(mIndex));
  k_cat (temp, UNIQUE_NAME_SUFFIX);
  k_cat (temp, s);
  */
  
  mIndex++;

  return temp;
}

#endif